Subject: [DNSOP] New Version Notification for draft-pp-additional-contents-00.txt

From: Paul Hoffman <[email-masked]>
Date: Wed, 16 Jun 2021 17:27:42 +0000

Greetings again. Peter van Dijk and I have just published a small informative document in response to some assertions about what can be in the Additional section of DNS responses, as well as what is "glue". This is not meant to be on standards track.

--Paul and Peter

> A new version of I-D, draft-pp-additional-contents-00.txt
> has been successfully submitted by Paul Hoffman and posted to the
> IETF repository.
> 
> Name:		draft-pp-additional-contents
> Revision:	00
> Title:		The Additional Section and Glue in DNS Responses
> Document date:	2021-06-16
> Group:		Individual Submission
> Pages:		5
> URL:            https://www.ietf.org/archive/id/draft-pp-additional-contents-00.txt <https://urldefense.com/v3/__https://www.ietf.org/archive/id/draft-pp-additional-contents-00.txt__;!!PtGJab4!t-Aauf-02j5Iyfzscurvs1igEu1w-9aEq0T0CACUcRGD4C7z1rMkRsvVo8rd1hIQ-7H-KRwSSQ$> 
> Status:         https://datatracker.ietf.org/doc/draft-pp-additional-contents/ <https://datatracker.ietf.org/doc/draft-pp-additional-contents/> 
> Htmlized:       https://datatracker.ietf.org/doc/html/draft-pp-additional-contents <https://datatracker.ietf.org/doc/html/draft-pp-additional-contents> 
> 
> 
> Abstract:
>   Implementers have recently expressed different views on what can
>   appear in the Additional section in DNS responses.  Proposals for
>   adding functionality to the DNS protocol that rely on non-glue
>   records in the Additional section rely on having a common
>   understanding of the semantics of the Additional section.
> 
>   This document restates what has been said in other DNS standards, and
>   does not update any of them.

---

From: Ben Schwartz <[email-masked]>
Date: Wed, 16 Jun 2021 13:39:12 -0400

Thanks.  I'm a bit confused though.  Your draft says "Non-address records
that appear in the Additional section are not considered glue as that term
is used in existing RFCs".  You also quote RFC 2181: '"Glue" above includes
any record in a zone file that is not properly part of that zone, including
nameserver records ...'. Is RFC 2181 not an existing RFC?

On Wed, Jun 16, 2021 at 1:28 PM Paul Hoffman <[email-masked]> wrote:

> Greetings again. Peter van Dijk and I have just published a small
> informative document in response to some assertions about what can be in
> the Additional section of DNS responses, as well as what is "glue". This is
> not meant to be on standards track.
>
> --Paul and Peter
>
>
> URL:
> https://www.ietf.org/archive/id/draft-pp-additional-contents-00.txt
> <https://urldefense.com/v3/__https://www.ietf.org/archive/id/draft-pp-additional-contents-00.txt__;!!PtGJab4!t-Aauf-02j5Iyfzscurvs1igEu1w-9aEq0T0CACUcRGD4C7z1rMkRsvVo8rd1hIQ-7H-KRwSSQ$>
>
> Status:
> https://datatracker.ietf.org/doc/draft-pp-additional-contents/
> Htmlized:
> https://datatracker.ietf.org/doc/html/draft-pp-additional-contents
>
>
> Abstract:
> _______________________________________________
> DNSOP mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dnsop
>

---

From: Paul Hoffman <[email-masked]>
Date: Wed, 16 Jun 2021 17:52:21 +0000

On Jun 16, 2021, at 10:39 AM, Ben Schwartz <[email-masked]> wrote:
> 
> Thanks.  I'm a bit confused though.  Your draft says "Non-address records that appear in the Additional section are not considered glue as that term is used in existing RFCs".  You also quote RFC 2181: '"Glue" above includes any record in a zone file that is not properly part of that zone, including nameserver records ...'.  Is RFC 2181 not an existing RFC?

Of course it is an existing RFC: that's why we referenced it.

Section 3 of the draft has three quotes about glue. The first two make it clear that RFC 1034 only considers glue to be addresses, while RFC 2181 does not. The conclusion of the draft is that the original definition is the correct one.

--Paul Hoffman

---

From: Ben Schwartz <[email-masked]>
Date: Wed, 16 Jun 2021 14:17:55 -0400

OK, but this is bewildering in a different way.

RFC 2181 is a Standards Track RFC that Updates RFC 1034, and whose title is
"Clarifications to the DNS Specification".  In the event of conflict, it
supersedes RFC 1034.  As a matter of process, the RFC 1034 definition would
therefore seem to be irrelevant for determining the "correct" meaning.

If I were arguing that the RFC 2181 definition is not "correct", I would be
looking for an RFC that Updates RFC 2181 and has a different definition of
glue.  The DNSSEC RFCs do Update RFC 2181, and appear to use a conflicting
definition of glue, although it's not explicitly defined.  Is that the
argument you are making?

Given the quotes you provided, I would be more likely to conclude that the
existing standards-track RFCs use conflicting definitions of "glue", and a
new standards-track document or erratum would be needed in order to resolve
the discrepancy.

On Wed, Jun 16, 2021 at 1:52 PM Paul Hoffman <[email-masked]> wrote:

> > Thanks.  I'm a bit confused though.  Your draft says "Non-address
> records that appear in the Additional section are not considered glue as
> that term is used in existing RFCs".  You also quote RFC 2181: '"Glue"
> above includes any record in a zone file that is not properly part of that
> zone, including nameserver records ...'.  Is RFC 2181 not an existing RFC?
>
> Section 3 of the draft has three quotes about glue. The first two make it
> clear that RFC 1034 only considers glue to be addresses, while RFC 2181
> does not. The conclusion of the draft is that the original definition is
> the correct one.
>
> --Paul Hoffman

---

From: Paul Hoffman <[email-masked]>
Date: Wed, 16 Jun 2021 18:40:15 +0000

> OK, but this is bewildering in a different way.

Indeed. See the muddle about "glue" in RFC 8499.

> RFC 2181 is a Standards Track RFC that Updates RFC 1034, and whose title is "Clarifications to the DNS Specification".  In the event of conflict, it supersedes RFC 1034.  As a matter of process, the RFC 1034 definition would therefore seem to be irrelevant for determining the "correct" meaning.

This is an overinterpretation of "updates". An RFC can update another without updating every part of it. Note that RFC 2181 only defines "glue" for its own use "above"; it does not say that it updates the definition in RFC 1034.

> If I were arguing that the RFC 2181 definition is not "correct", I would be looking for an RFC that Updates RFC 2181 and has a different definition of glue.

Such as RFC 8499 (which is a standard), or this one (the, if adopted, is only informational).

>  The DNSSEC RFCs do Update RFC 2181, and appear to use a conflicting definition of glue, although it's not explicitly defined.

And those RFCs kinda conflict with each other on the use of the term "glue".

--Paul Hoffman